# std::basic_string<CharT,Traits,Allocator>::begin, std::basic_string<CharT,Traits,Allocator>::cbegin

From cppreference.com
< cpp‎ | string‎ | basic string

| (1) |
iterator begin(); |  | (until C++11)
iterator begin() noexcept; |  | (since C++11)
| (2) |
const_iterator begin() const; |  | (until C++11)
const_iterator begin() const noexcept; |  | (since C++11)
const_iterator cbegin() const noexcept; | (3) | (since C++11)

Returns an iterator to the first character of the string.

`begin()` returns a mutable or constant iterator, depending on the constness of *this.

`cbegin()` always returns a constant iterator. It is equivalent to const_cast<const basic_string&>(*this).begin().

### Parameters

(none)

### Return value

iterator to the first character

### Complexity

Constant

### Example

Run this code

    #include <string>
    #include <iostream>

    int main()
    {
        std::string s("Exemplar");
        *s.begin() = 'e';
        std::cout << s <<'\n';

        auto i = s.cbegin();
        std::cout << *i << '\n';
    //  *i = 'E'; // error: i is a constant iterator
    }

Output:

    exemplar
    e

### See also

end cend (C++11) | returns an iterator to the end (public member function)

Retrieved from "https://en.cppreference.com/mwiki/index.php?title=cpp/string/basic_string/begin&oldid=110140"